<?php
namespace App\Http\Controllers\Category\Controller;

use App\Http\Controllers\ControllerBase;

class Category extends ControllerBase
{

    protected $prefix = "cates";

    public function pretty()
    {
        empty($query) && $query = request()->getQueryString();
        try {
            $client = app("client");
            $client->setUrl($this->prefix."?".$query);
            $client->setMethod("get");
            $res = $client->curl();
            $res = $this->list_to_tree($res,"id","previous");
            return Response::success($res);
        } catch (\Exception $e) {
            return Response::error($e->getMessage());
        }
    }

    public function index($query = "", $checkUid = true)
    {
        $query = $this->combine(['size' => 1000]);
        return parent::index($query, $checkUid);
    }

    protected function list_to_tree($list, $pk='id', $pid = 'pid', $child = 'child', $root = 0) {
        $tree = array();
        if(is_array($list)) {
            $refer = array();
            foreach ($list as $key => $data) {
                $refer[$data[$pk]] =& $list[$key];
            }
            foreach ($list as $key => $data) {
                $parentId =  $data[$pid];
                if ($root == $parentId) {
                    $tree[] =& $list[$key];
                }else{
                    if (isset($refer[$parentId])) {
                        $parent =& $refer[$parentId];
                        $parent[$child][] =& $list[$key];
                    }
                }
            }
        }
        return $tree;
    }

}